/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.human.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.action.MosPHumanAction;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

import jp.mosp.human.dto.MKihonDto;
import jp.mosp.human.vo.HumanKihonCardVo;

public class HumanKihonCardAction extends MosPHumanAction {

	// コマンド
	public  static final String CMD_HUMAN_BASIS_SHOW      = "H1020";
	private static final String CMD_HUMAN_BASIS_SELECT    = "H1021";
	private static final String CMD_HUMAN_BASIS_INSERT    = "H1022";
	private static final String CMD_HUMAN_BASIS_UPDATE    = "H1023";

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// HUMAN権限確認
		confirmHumanAuth();
		// VOの取得
		HumanKihonCardVo vo = (HumanKihonCardVo) prepareVo();
		init(vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_HUMAN_BASIS_SHOW)) {
			// 表示(新規)
			show(vo);
		} else if (cmd.equals(CMD_HUMAN_BASIS_SELECT)) {
			// 表示(社員コードで情報を検索)
			select(vo);
		} else if (cmd.equals(CMD_HUMAN_BASIS_INSERT)) {
			// 登録
			insert(vo);
		} else if (cmd.equals(CMD_HUMAN_BASIS_UPDATE)) {
			// 更新
			update(vo);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	protected BaseVo getSpecificVo() {
		return new HumanKihonCardVo();
	}

	/**
	 * 初期処理
	 * @param vo	対象VO
	 */
	protected void init(HumanKihonCardVo vo) throws Exception {
		// パラメータ取得
		vo.setParams(request);
		// ボタン内容設定
		setListButton(vo);
		// プルダウン設定
		setPulldown(vo);
	}

	/**
	 * 新規登録画面表示
	 * @param vo 対象VO
	 * @throws Exception
	 */
	protected void show(HumanKihonCardVo vo) throws Exception {
		// モード設定
		vo.setMode(HumanKihonCardVo.MODE_INSERT);
		// 選択社員コード取得
		String kCode = vo.getTxtChangeKCode();
		// VO初期化
		vo.initFields();
		vo.setTxtKCode(kCode);
		Date date = util.getSystemDate();
		vo.setPltEntranceYear (String.valueOf(MospUtility.getYear	(date)));
		vo.setPltEntranceMonth(String.valueOf(MospUtility.getMonth	(date)));
		vo.setPltEntranceDay  (String.valueOf(MospUtility.getDay	(date)));
	}

	/**
	 * データ表示
	 * @param vo 対象VO
	 * @throws Exception
	 */
	protected void select(HumanKihonCardVo vo) throws Exception {
		// 表示(社員コードで情報を検索)
		// 選択社員コード取得
		String kCode = "";
		if (vo.getTxtChangeKCode() != null && !vo.getTxtChangeKCode().equals("") ) {
			kCode = vo.getTxtChangeKCode();
		} else if (key1 != null && !key1.equals("")) {
			kCode = key1;
		} else {
			kCode = vo.getTxtKCode();
		}
		// 人事基本情報取得
		getHumanBasisInfo(kCode, vo);
		// セッションにDTOをセット
		setStoredDto();
	}

	/**
	 * 挿入処理
	 * @param vo 対象VO
	 * @throws Exception
	 */
	protected void insert(HumanKihonCardVo vo) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// 人事基本情報用DAO準備
		prepareHumanBasisDao();
		// マスタデータ存在確認
		chkDuplicate(mKihonDao.findForKey(vo.getTxtKCode()), vo);
		// 登録処理
		String message = regist(vo);
		// コミット
		commit();
		// 人事基本情報取得
		getHumanBasisInfo(vo.getTxtKCode(), vo);
		// メッセージ設定
		vo.setMessage(message);
		// セッションにDTOをセット
		setStoredDto();
	}

	/**
	 * 更新処理
	 * @param vo 対象VO
	 * @throws Exception
	 */
	protected void update(HumanKihonCardVo vo) throws Exception {
		// セッション保持DTO取得
		getStoredDto();
		// パラメータの妥当性確認
		vo.validate();
		// 人事基本情報用DAO準備
		prepareHumanBasisDao();
		// 登録処理
		String message = regist(vo);
		// コミット
		commit();
		// 人事基本情報取得
		getHumanBasisInfo(vo.getTxtKCode(), vo);
		// メッセージ設定
		vo.setMessage(message);
		// セッションにDTOをセット
		setStoredDto();
	}

	/**
	 * プルダウン設定
	 * @param vo 対象VO
	 * @throws Exception
	 */
	protected void setPulldown(HumanKihonCardVo vo) throws Exception {
		// プルダウン設定
		if (vo.aryPltSectionAll != null) {
			return;
		}
		Date date = util.getSystemDate();
		vo.aryPltOfficeAll		= getOfficeArrayAll();
		vo.aryPltOffice			= getOfficeArray();
		vo.aryPltSectionAll		= getSectionArrayAll();
		vo.aryPltSection		= getSectionArrayForHuman();
		vo.aryPltPositionAll	= getPositionArrayAll();
		vo.aryPltPosition		= getPositionPltArray();
		vo.aryPltRetirement		= util.getRetirementFlagArray();
		vo.aryPltYear			= util.getYearArray(MospUtility.getYear (date), 80, 1);
		vo.aryPltMonth			= util.getMonthArray();
		vo.aryPltDay			= util.getDayArray();
	}

	/**
	 * 情報取得処理
	 * @param kCode 取得対象社員コード
	 * @param vo    情報設定対象VO
	 * @throws Exception
	 */
	protected void getHumanBasisInfo(String kCode, HumanKihonCardVo vo) throws Exception {
		// 人事基本情報取得
		findHumanBasisInfo(kCode, false);
		// 対象データ存在確認
		if (mKihonDto == null) {
			addErrMessage(MospUtility.getMessage(msg, CommonConst.MSG_NO_HUMAN_DATA, ""));
			vo.setTxtChangeKCode(kCode);
			show(vo);
			return;
		}
		// VO初期化
		vo.initFields();
		vo.setTxtChangeKCode(kCode);
		// VOに情報を設定
		vo.setFields(mKihonDto);
		vo.setMode(HumanKihonCardVo.MODE_UPDATE);
		// セッション保持用DTO設定
		storedmKihonDto = mKihonDto;
		// 排他情報設定
		String editor = setExclusive(CommonConst.EXC_HUMAN_BASIS, user.getUserId(), kCode);
		if (editor != null) {
			addErrMessage(MospUtility.getMessage(msg, CommonConst.MSG_EXCLUSIVE, editor));
		}
		setNeedExclusive(true);
	}

	/**
	 * 登録処理
	 * @param vo 対象VO
	 * @return メッセージ
	 * @throws Exception
	 */
	protected String regist(HumanKihonCardVo vo) throws Exception {
		// DBコネクション取得
		if (conn == null) {
			getConnection();
		}
		// DTO準備
		mKihonDto = storedmKihonDto;
		if (mKihonDto == null) {
			mKihonDto = new MKihonDto();
		}
		vo.setDtoFields(mKihonDto);
		// 存在確認
		String message = "";
		MKihonDto duplicateDto = mKihonDao.findForUpdate(mKihonDto.getKCode());
		if (duplicateDto == null) {
			// 新規登録
			mKihonDao.insert(mKihonDto);
			applyHistory(mKihonDto.getKCode(), false, vo);
			message = MospUtility.getMessage(msg, MospConst.MSG_INSERT, "");
		} else {
			// 更新
			mKihonDao.update(mKihonDto);
			applyHistory(mKihonDto.getKCode(), true, vo);
			message = MospUtility.getMessage(msg, MospConst.MSG_UPDATE, "");
		}
		return message;
	}

}
